#### POSIX Threads for Windows – REFERENCE - Pthreads-w32

Reference Index

Table of Contents

## Name

pthread_condattr_getpshared, pthread_condattr_setpshared - get and set the process-shared condition variable attributes

## Synopsis

#include <pthread.h>

int pthread_condattr_getpshared(const pthread_condattr_t *restrict attr, int *restrict pshared);
int pthread_condattr_setpshared(pthread_condattr_t *attr, int pshared);

## Description

The pthread_condattr_getpshared function shall obtain the value of the process-shared attribute from the attributes object referenced by attr. The pthread_condattr_setpshared function shall set the process-shared attribute in an initialized attributes object referenced by attr.

The process-shared attribute is set to PTHREAD_PROCESS_SHARED to permit a condition variable to be operated upon by any thread that has access to the memory where the condition variable is allocated, even if the condition variable is allocated in memory that is shared by multiple processes. If the process-shared attribute is PTHREAD_PROCESS_PRIVATE, the condition variable shall only be operated upon by threads created within the same process as the thread that initialized the condition variable; if threads of differing processes attempt to operate on such a condition variable, the behavior is undefined. The default value of the attribute is PTHREAD_PROCESS_PRIVATE.

Pthreads-w32 defines _POSIX_THREAD_PROCESS_SHARED in pthread.h as -1 to indicate that these routines are implemented but that the process shared attribute is not supported.

## Return Value

If successful, the pthread_condattr_setpshared function shall return zero; otherwise, an error number shall be returned to indicate the error.

If successful, the pthread_condattr_getpshared function shall return zero and store the value of the process-shared attribute of attr into the object referenced by the pshared parameter. Otherwise, an error number shall be returned to indicate the error.

## Errors

The pthread_condattr_getpshared and pthread_condattr_setpshared functions may fail if:

EINVAL
  The value specified by attr is invalid.

The pthread_condattr_setpshared function may fail if:

EINVAL
  The new value specified for the attribute is outside the range of legal values for that attribute.
ENOSYS
  The value specified by attr was PTHREAD_PROCESS_SHARED (Pthreads-w32).

These functions shall not return an error code of [EINTR].

The following sections are informative.

## Examples

None.

## Application Usage

Pthreads-w32 defines _POSIX_THREAD_PROCESS_SHARED in pthread.h as -1 to indicate that these routines are implemented and may be used, but do not support the process shared option.

## Rationale

None.

## Future Directions

None.

## See Also

pthread_create(3) , pthread_cond_destroy(3) , pthread_condattr_destroy(3) , pthread_mutex_destroy(3) , the Base Definitions volume of IEEE Std 1003.1-2001, <pthread.h>

## Copyright

Portions of this text are reprinted and reproduced in electronic form from IEEE Std 1003.1, 2003 Edition, Standard for Information Technology -- Portable Operating System Interface (POSIX), The Open Group Base Specifications Issue 6, Copyright (C) 2001-2003 by the Institute of Electrical and Electronics Engineers, Inc and The Open Group. In the event of any discrepancy between this version and the original IEEE and The Open Group Standard, the original IEEE and The Open Group Standard is the referee document. The original Standard can be obtained online at http://www.opengroup.org/unix/online.html .

Modified by Ross Johnson for use with Pthreads-w32.

Table of Contents

- Name

- Synopsis

- Description

- Return Value

- Errors

- Examples

- Application Usage

- Rationale

- Future Directions

- See Also

- Copyright